#!/bin/sh
#
#
. ./proc-helper
#
release_ver="1.1.0~"

echo "*****************************************"
echo "*** Script zur Anpassung der Firmware ***"
echo "*****************************************"
echo

check=`cat /lib/gluon/release | grep $release_ver`
if [ "$check" == "" ]
then
###########################################
echo
echo "Dieses Patch ist fuer diese Version der Firmware NICHT geeignet!"
echo
echo "Bitte eine passende Version herunterladen (falls ueberhaupt ein Patch erforderlich ist) und"
echo "diese dann ausfuehren ..."
echo
###########################################
else
###########################################
echo "-> passe Config-Vorgaben an ffhal an..."
###########################################
ffhal_params_and_files

##3xuci set gluon-setup-mode.@setup_mode[0].configured='1'
echo

###########################################
##32echo "-> setze Netzwerk-Parameter zu ffhal..."
###########################################
##32echo -n "."; uci set fastd.sample_config.mtu='1426'
##32echo -n "."; uci set fastd.mesh_vpn.mtu='1426'
##32echo -n "."; uci set network.mesh_vpn.mtu='1426'
##32echo -n "."; uci set network.local_node_dev.macaddr='02:dd:9e:0b:50:1c'
##32echo -n "."; uci set network.local_node.ipaddr='10.62.0.100/16'
##32echo -n "."; uci set network.local_node.ip6addr='fd0f:8db3:d50a::100/128'
##32echo -n "."; uci set network.local_node_route6.target='fd0f:8db3:d50a::/64'
##nowdate=`date -u +"%Y %m %d %H %M"`
##set -- `echo $nowdate`
##yr=$1; mn=$2; dy=$3; hr=$4; mi=$5
##echo "8"; uci set system.@system[0].hostname="ffhal-CPE210v3-$yr$mn$dy$hr$mi"
##32devdata=`ip a s dev eth0`; set -- `echo $devdata`; devdata=`echo $15`; devdata=`echo $devdata | sed  's/://g'`
###echo "8"; uci set system.@system[0].hostname="ffhal-CPE210v3-adaptiert"
##32echo "ok";   uci set system.@system[0].hostname="ffhal-$devdata"
##32echo

###########################################
##3yecho "-> passe weitere Netzwerkeintrge an..."
###########################################
##32echo -n "."; uci set network.mesh_radio0=interface
##32echo -n "."; uci set network.mesh_radio0.proto='gluon_mesh'
##3yecho -n "."; uci del network.mesh_wan.index
##3yecho -n "."; uci set network.mesh_wan.auto='0'
##3yecho -n "."; uci set network.mesh_wan.fixed_mtu='1'
##3yecho -n "."; uci set network.mesh_wan.proto='gluon_mesh'
##3yecho -n "."; uci del network.client.ra_holdoff
##3yecho -n "."; uci del network.gluon_bat0.gw_mode
##3yecho "ok";   uci set network.mesh_wan.disabled='1'

##3yuci commit
##3yecho

###########################################
##3xecho "-> erstelle alfred und richte es ein..."
###########################################
##32echo -n "touching..."; touch /etc/config/alfred

##32echo -n "."; uci set alfred.alfred=alfred
##32echo -n "."; uci set alfred.alfred.batmanif='bat0'
##32echo -n "."; uci set alfred.alfred.start_vis='1'
##32echo -n "."; uci set alfred.alfred.mode='slave'
##32echo -n "."; uci set alfred.alfred.run_facters='0'
##32echo "ok";   uci set alfred.alfred.interface='br-client'

##32uci commit

##########################################
##3xrm -f /etc/rc.d/S99alfred >/dev/null
##3xrm -f /etc/rc.d/K99alfred >/dev/null
##3xalfred_files
##3xecho

##3y###########################################
##3yecho "-> erstelle batman-adv und richte es ein..."
##3y###########################################
##3yecho -n "touching..."; touch /etc/config/batman-adv

##3yecho -n "."; uci set batman-adv.bat0=mesh
##3yecho -n "."; uci set batman-adv.bat0.gw_mode='client'
##3yecho -n "."; uci set batman-adv.bat0.orig_interval='5000'
##3yecho -n "."; uci set batman-adv.bat0.routing_algo='BATMAN_IV'
##3yecho -n "."; uci set batman-adv.bat0.hop_penalty='15'
##3yecho -n "."; uci set batman-adv.bat0.gw_sel_class='1'
##3yecho "ok";   uci set batman-adv.bat0.multicast_mode='0'

##3yuci commit

##########################################
##3ybatman_files
##3yecho

##########################################
# bermittlung der Infos an die Seite
# passiert in Halle mit respondd,
# allerdings funktioniert das mit der
# Version vom Image nicht
##########################################
echo "-> kopiere Dateien von respondd..."
###########################################
respondd_files
echo

###########################################
##32echo "-> passe Autoupdater-Eintrge an..."
###########################################
##32echo -n "."; uci del autoupdater.nightly
##32echo -n "."; uci del autoupdater.beta
##32echo -n "."; uci del autoupdater.stable.mirror
##32echo -n "."; uci add_list autoupdater.stable.mirror='http://mirror1.ffhal/stable/images/sysupgrade/'
##32echo -n "."; uci add_list autoupdater.stable.mirror='http://mirror2.ffhal/stable/images/sysupgrade/'
##32echo -n "."; uci del autoupdater.stable.pubkey
##32echo -n "."; uci add_list autoupdater.stable.pubkey='8c52cae214514856aa0502b1684eeebc8f7f95315e618b6743219d93ac0700be'
##32echo -n "."; uci add_list autoupdater.stable.pubkey='5e8fa01f6f2f963c0d96e07eaf91c29e09b10ffb2100fa5ab8eee92a25ddede9'
##32echo -n "."; uci set autoupdater.stable.good_signatures='1'
##32echo -n "."; uci del autoupdater.experimental.mirror
##32echo -n "."; uci add_list autoupdater.experimental.mirror='http://mirror1.ffhal/experimental/images/sysupgrade/'
##32echo -n "."; uci add_list autoupdater.experimental.mirror='http://mirror2.ffhal/experimental/images/sysupgrade/'
##32echo -n "."; uci set autoupdater.experimental.good_signatures='1'
##32echo -n "."; uci del autoupdater.experimental.pubkey
##32echo -n "."; uci add_list autoupdater.experimental.pubkey='8c52cae214514856aa0502b1684eeebc8f7f95315e618b6743219d93ac0700be'
##32echo -n "."; uci add_list autoupdater.experimental.pubkey='5e8fa01f6f2f963c0d96e07eaf91c29e09b10ffb2100fa5ab8eee92a25ddede9'
##32echo "ok";   uci set autoupdater.settings.enabled='0'

##32uci commit

############################################
#echo "entferne dnsmasq's nonwildcard..."
############################################
#uci del dhcp.@dnsmasq[0].nonwildcard

##uci commit

##32echo

##3y###########################################
##3yecho "-> passe dhcp client Eintrge an..."
##3y###########################################
##3yecho -n "."; uci del dhcp.local_client
##3yecho -n "."; uci set dhcp.client=dhcp
##3yecho -n "."; uci set dhcp.client.ignore='1'
##3yecho "ok";   uci set dhcp.client.interface='client'

##3yecho

##3x###########################################
##3xecho "-> passe VPN Eintrge an..."
##3x###########################################
##32echo -n "vpn on connect: ";  uci del fastd.mesh_vpn.on_connect           # ein Auge drauf!!

##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw01
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw02
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw03
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw04
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw05
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw06
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw07
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw08
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw09
##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_gw10

##32echo -n "."; uci set fastd.mesh_vpn_backbone_peer_vpn3=peer
##32echo -n "."; uci set fastd.mesh_vpn_backbone_peer_vpn3.enabled='1'
##32echo -n "."; uci set fastd.mesh_vpn_backbone_peer_vpn3.key='c21abf04f9ee3a1906607cf4c8e734addaa8bba8eeb3d405be76248082b0b748'
##32echo -n "."; uci set fastd.mesh_vpn_backbone_peer_vpn3.net='mesh_vpn'

##32echo -n "."; uci del fastd.mesh_vpn_backbone_peer_vpn3.remote
##32echo -n "."; uci add_list fastd.mesh_vpn_backbone_peer_vpn3.remote='"vpn3.freifunk-halle.org" port 10000'

##32echo -n "."; uci set fastd.mesh_vpn_backbone_peer_vpn3.group='mesh_vpn_backbone'

##32echo -n "."; uci del fastd.mesh_vpn.method
##32echo -n "."; uci add_list fastd.mesh_vpn.method='null'

##32echo "ok";   uci set fastd.mesh_vpn.enabled='1'

##3xecho "ok"; uci set fastd.sample_config.secure_handshakes='1'

###########################################
# for debug...                            #
###########################################
# echo "21S"; uci set fastd.mesh_vpn.secret='10c0ac0a49bed094c6b1f1eda54fc73efc3c5ff36834028c4dc2ee8ce5414b47'
###########################################

uci commit
echo

##3x###########################################
##3xecho "-> passe firewall an..."
##3x###########################################
##3xecho -n "."; uci del firewall.wan_vxlan
##3xecho -n "."; uci del firewall.wired_mesh_vxlan
##3xecho -n "."; uci set firewall.@defaults[0].input='ACCEPT'

##3xecho -n "."; uci del firewall.mesh
##3xecho -n "."; uci del firewall.mesh_ICMPv6_in
##3xecho -n "."; uci del firewall.local_client
##3xecho -n "."; uci del firewall.local_client_ICMPv6_in
##3xecho -n "."; uci del firewall.wired_mesh
##3xecho -n "."; uci del firewall.wired_mesh_ICMPv6_in
##3xecho -n "."; uci del firewall.local_client_ICMPv4_in
##3xecho -n "."; uci del firewall.local_client_ssh

##3xecho -n "."; uci set firewall.client=zone
##3xecho -n "."; uci set firewall.client.name='client'
##3xecho -n "."; uci set firewall.client.network='client'
##3xecho -n "."; uci set firewall.client.input='ACCEPT'
##3xecho -n "."; uci set firewall.client.forward='REJECT'
##3xecho -n "."; uci set firewall.client.output='ACCEPT'
##3xecho -n "."; uci set firewall.client_dns=rule
##3xecho -n "."; uci set firewall.client_dns.dest_port='53'
##3xecho -n "."; uci set firewall.client_dns.src='client'
##3xecho -n "."; uci set firewall.client_dns.name='client_dns'
##3xecho -n "."; uci set firewall.client_dns.target='REJECT'

##3xecho -n "."; uci set firewall.local_node=zone
##3xecho -n "."; uci set firewall.local_node.name='local_node'
##3xecho -n "."; uci set firewall.local_node.input='ACCEPT'
##3xecho -n "."; uci set firewall.local_node.forward='REJECT'
##3xecho -n "."; uci set firewall.local_node.network='local_node'
##3xecho -n "."; uci set firewall.local_node.output='ACCEPT'

##3xecho -n "."; uci del firewall.mesh_ssh
##3xecho -n "."; uci del firewall.drop

##3xecho -n "."; uci del firewall.mesh_respondd

##3xecho -n "."; uci del firewall.mesh_respondd_reply
##3xecho -n "."; uci del firewall.mesh_respondd_ll
##3xecho -n "."; uci del firewall.mesh_respondd_siteprefix
##3xecho -n "."; uci set firewall.client_respondd.src='client'
##3xecho -n "."; uci set firewall.client_respondd.src_ip='!fe80::/64'
##3xecho -n "."; uci set firewall.client_respondd.target='REJECT'
##3xecho -n "."; uci del firewall.mesh_http
##3xecho "ok";   uci del firewall.local_client_http

##3xuci commit
##3xecho

###########################################
##32echo "-> setze Modus als Knoten..."
###########################################
##32uci set gluon-node-info.@system[0].role='node'

##32uci commit gluon-node-info

##32echo

##3x###########################################
##3xecho "-> passe ssid changer an..."
##3x###########################################
# uci set ssid-changer.settings=main
##3xecho -n "touching..."; touch /etc/config/ssid-changer

##3xecho -n "."; uci set ssid-changer.settings=settings
##3xecho -n "."; uci set ssid-changer.settings.enabled='1'
##3xecho -n "."; uci set ssid-changer.settings.tq_limit_max='45'
##3xecho -n "."; uci set ssid-changer.settings.suffix='nodename'
##3xecho -n "."; uci set ssid-changer.settings.tq_limit_min='35'
##3xecho -n "."; uci set ssid-changer.settings.switch_timeframe='15'
##3xecho -n "."; uci set ssid-changer.settings.tq_limit_enabled='0'
##3xecho -n "."; uci set ssid-changer.settings.first='5'
##3xecho "ok";   uci set ssid-changer.settings.prefix='Offline_www.freifunk-halle.org_'

##3xuci commit

###########################################
# uci set uhttpd.defaults.commonname='LEDE'
##3xecho

###########################################
echo "-> passe ntp Einstellungen an..."
###########################################
echo -n "."; uci del system.ntp.server

echo -n "."; uci add_list system.ntp.server='time1.service.ffhal'
echo -n "."; uci add_list system.ntp.server='time2.service.ffhal'
echo -n "."; uci add_list system.ntp.server='fd0f:8db3:d50a:0:208:a1ff:fe25:cf0a'
echo -n "."; uci add_list system.ntp.server='131.188.3.220'
echo -n "."; uci add_list system.ntp.server='131.188.3.221'
echo "ok";   uci add_list system.ntp.server='131.188.3.222'

uci commit
echo

###########################################
echo "-> passe LED-Steuerung an..."
###########################################
echo -n "."; uci set system.led_rssilow=led
echo -n "."; uci set system.led_rssilow.sysfs='tp-link:green:link1'
echo -n "."; uci set system.led_rssilow.trigger='rssi'
echo -n "."; uci set system.led_rssilow.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssilow.minq='1'
echo -n "."; uci set system.led_rssilow.maxq='100'
echo -n "."; uci set system.led_rssilow.offset='0'
echo -n "."; uci set system.led_rssilow.factor='13'
echo -n "."; uci set system.led_rssimediumlow=led
echo -n "."; uci set system.led_rssimediumlow.sysfs='tp-link:green:link2'
echo -n "."; uci set system.led_rssimediumlow.trigger='rssi'
echo -n "."; uci set system.led_rssimediumlow.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssimediumlow.minq='22'
echo -n "."; uci set system.led_rssimediumlow.maxq='100'
echo -n "."; uci set system.led_rssimediumlow.offset='-21'
echo -n "."; uci set system.led_rssimediumlow.factor='13'
echo -n "."; uci set system.led_rssimediumhigh=led
echo -n "."; uci set system.led_rssimediumhigh.sysfs='tp-link:green:link3'
echo -n "."; uci set system.led_rssimediumhigh.trigger='rssi'
echo -n "."; uci set system.led_rssimediumhigh.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssimediumhigh.minq='43'
echo -n "."; uci set system.led_rssimediumhigh.maxq='100'
echo -n "."; uci set system.led_rssimediumhigh.offset='-42'
echo -n "."; uci set system.led_rssimediumhigh.factor='13'
echo -n "."; uci set system.led_rssihigh=led
echo -n "."; uci set system.led_rssihigh.sysfs='tp-link:green:link4'
echo -n "."; uci set system.led_rssihigh.trigger='rssi'
echo -n "."; uci set system.led_rssihigh.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssihigh.maxq='100'
echo -n "."; uci set system.led_rssihigh.factor='13'
echo -n "."; uci set system.led_rssihigh.minq='64'
echo -n "."; uci set system.led_rssihigh.offset='-63'
echo -n "."; uci set system.led_lan=led
echo -n "."; uci set system.led_lan.name='LAN'
echo -n "."; uci set system.led_lan.sysfs='tp-link:green:lan0'
echo -n "."; uci set system.led_lan.trigger='netdev'
echo -n "."; uci set system.led_lan.mode='link tx rx'
echo "ok";   uci set system.led_lan.dev='eth0'

echo -n "RSSI LEDs: "; /etc/init.d/rssileds reload
echo "....ok"
echo -n "LAN LED  : "; /etc/init.d/led reload
#echo "....ok"

uci commit
echo

###########################################
echo "-> DAC524's Workaround wegen mesh0..."
###########################################
dac524_files

echo
###########################################
echo "-> passe WLAN Einstellungen an..."
###########################################
# uci del wireless.radio0.legacy_rates

echo -n "."; uci del wireless.radio0.supported_rates 2> /dev/null

echo -n "."; uci add_list wireless.radio0.supported_rates='6000'
echo -n "."; uci add_list wireless.radio0.supported_rates='9000'
echo -n "."; uci add_list wireless.radio0.supported_rates='12000'
echo -n "."; uci add_list wireless.radio0.supported_rates='18000'
echo -n "."; uci add_list wireless.radio0.supported_rates='24000'
echo -n "."; uci add_list wireless.radio0.supported_rates='36000'
echo -n "."; uci add_list wireless.radio0.supported_rates='48000'
echo -n "."; uci add_list wireless.radio0.supported_rates='54000'

echo -n "."; uci del wireless.radio0.basic_rate 2> /dev/null

echo -n "."; uci add_list wireless.radio0.basic_rate='6000'
echo -n "."; uci add_list wireless.radio0.basic_rate='9000'
echo -n "."; uci add_list wireless.radio0.basic_rate='18000'
echo -n "."; uci add_list wireless.radio0.basic_rate='36000'
echo "ok";   uci add_list wireless.radio0.basic_rate='54000'

##3yecho -n "."; uci set gluon.wireless.outdoor='1'

##3yecho -n "."; uci set wireless.radio0.channel='13'
## echo -n "."; uci set wireless.radio0.country='DE'
##3yecho -n "."; uci set wireless.mesh_radio0.mesh_id='02:CA:FF:EE:BA:BE'
##3yecho "ok";   uci set wireless.client_radio0.ssid='www.freifunk-halle.org'

uci commit

v_respond=$(pidof respondd)
if [ $v_respond ]
then
 echo -n "WLAN restart...."
 wifi
 echo "ok"
fi

###########################################
echo
echo "Falls der Router aktuell im Config Mode laeuft, diesen bitte jetzt neu starten!"
echo "Dies laesst sich hier mit dem Kommando reboot erreichen."
echo
echo "Falls der Router aktuell im Normalbetrieb laeuft und etwas nicht wie erwartet normal funktioniert,"
echo "bitte die laufenden Dienste ueberpruefen und ggf. neu starten. Im Zweifelsfall hilft reboot ..."
echo
###########################################
fi
